#ifndef DEBUG_HPP_INCLUDED
#define DEBUG_HPP_INCLUDED

#include "../../Include/Core/Types/Logger.hpp"

#define DEBUG_VERBOSE_LOG                   Debug::Verbose << __PRETTY_FUNCTION__ << " > "
#define DEBUG_VERBOSE_LOG_END               --Debug::Verbose << __PRETTY_FUNCTION__ << " > "
#define DEBUG_VERBOSE_START                 Debug::Verbose++ << __PRETTY_FUNCTION__ << " > Started" << std::endl

#define DEBUG_VERBOSE_SUCCESS               --Debug::Verbose << __PRETTY_FUNCTION__ << " > Succeeded > "
#define DEBUG_VERBOSE_SUCCESS_NOINFO        --Debug::Verbose << __PRETTY_FUNCTION__ << " > Succeeded" << std::endl
#define DEBUG_VERBOSE_SUCCESS_EOF           --Debug::Verbose << " > Succeeded > Reached end of function" << std::endl

#define DEBUG_VERBOSE_FAIL                  --Debug::Verbose << __PRETTY_FUNCTION__ << " > Failed > "
#define DEBUG_VERBOSE_FAIL_NOINFO           --Debug::Verbose << __PRETTY_FUNCTION__ << " > Failed" << std::endl;
#define DEBUG_VERBOSE_FAIL_EOF              --Debug::Verbose << __PRETTY_FUNCTION__ << " > Failed > Reached end of function" << std::endl

class Debug
{
    public:
        static Logger Info;
        static Logger Verbose;
        static Logger Warning;
        static Logger Error;
        static Logger Fatal;
        static Logger Internal;
        static Logger Paint;

        static void ShowConsole();
        static void HideConsole();
        static void SetVerbose(bool Toggle);

        static void EnableInput();
        static void DisableInput();

        static void Clear();
        static void Screenshot(const std::string& Path);
};


#endif // DEBUG_HPP_INCLUDED
