#ifndef LOGOUT_HPP_INCLUDED
#define LOGOUT_HPP_INCLUDED

#include "../../../Core/Types/Box.hpp"
#include "../../../Core/Classes/World.hpp"
#include "../../../Game/Interactable/Widget.hpp"
#include <cstdint>
#include <vector>

/** @addtogroup GameTabs
* @{ */
class Logout
{
    public:
        static bool IsOpen();
        static bool Open();
        static bool LogoutPlayer();

        static bool IsWorldSwitcherOpen(bool WaitToLoadWorlds = true);
        static bool OpenWorldSwitcher(bool WaitToLoadWorlds = true);

        static bool WorldSwitcherScrollTo(const Internal::World& World);
        static bool WorldSwitcherScrollTo(std::int32_t WorldID);

        static bool SwitchWorld(const Internal::World& World, bool AllowPVPWorlds = false, bool SetOnlyWarnAboutDangerousWorlds = false); // SetOnlyWarnAboutFutureWorlds will click "Yes. In future, only warn about dangerous worlds." instead of just "yes"
        static bool SwitchWorld(std::int32_t WorldID, bool AllowPVPWorlds = false, bool SetOnlyWarnAboutDangerousWorlds = false); // SetOnlyWarnAboutFutureWorlds will click "Yes. In future, only warn about dangerous worlds." instead of just "yes"

        static Interactable::Widget GetWorldWidget(const Internal::World& World);
        static Interactable::Widget GetWorldWidget(std::int32_t  WorldID);
};

/** @} */

#endif // LOGOUT_HPP_INCLUDED
